#---------------------------------
# Kibbles'n'Gibs : eventscript   |
# By Beefaloaf                   |
#---------------------------------
import es
import random
import gamethread
import vecmath
import effectlib
import cfglib
import random
#import srcds.entities

info = es.AddonInfo()
info.name = "Kibbles n Gibs"
info.version = "1.0"
info.author = "Beefaloaf"
info.url = "http://www.cheapergeek.net"
info.basename = "kibbles"
info.description = "When a player endures high explosion damage, doesn't it make sense that they blow apart??"
es.ServerVar('Kibbles_version', info.version, info.description).makepublic()

#CFG SECTION
config = cfglib.AddonCFG(es.getAddonPath("kibbles") + "/kibbles.cfg")

config.text("---------------------------------")
config.text("| Kibbles'n'Gibs : eventscript  |")
config.text("| By Beefaloaf                  |")
config.text("| support@cheapergeek.net       |")
config.text("---------------------------------")
config.text('\n')
config.text('Load this addon with: es_load ' + info.basename)
config.text('\n')
config.text('***** General options *****')
gibs_damage	= config.cvar('gibs_damage',         75,       'Final blow damage needed to gib player')
config.text('\n')
config.text('A player will only gib when killed by HEgrenades,')
config.text('C4 explosions, or unknown damage.  Kibbles must')
config.text('be a result of damage higher than gibs_damage.')
config.write()


modelList = ['brain.mdl','brain.vvd','brain.dx90.vtx','ear.mdl','ear.vvd','ear.dx90.vtx','femur.mdl','femur.vvd','femur.dx90.vtx','heart.mdl','heart.vvd','heart.dx90.vtx','stomach.mdl','stomach.vvd','stomach.dx90.vtx','verta.mdl','verta.vvd','verta.dx90.vtx','ribs.mdl','ribs.vvd','ribs.dx90.vtx']
materialList= ['bone.vmt','bone.vtf','brain.vmt','brain.vtf','ear.vmt','ear.vtf','heart.vmt','heart.vtf','pink.vmt','pink.vtf','skin.vmt','skin.vtf']
soundList = ['gib.mp3','tornoff2.mp3','udeath.mp3']

def load():
	global lastbombXYZ
	lastbombXYZ = "??? ??? ???"
	global lastbomb
	lastbomb = [0,1,2]
	#global shooter
	global c4XYZ
	c4XYZ = "??? ??? ???"
	global c4
	c4 = [0,1,2]
	global angle
	angle = "auto"
	global ragindex
	ragindex = []
	global vanish
	vanish = 0
	global kibble_permission
	kibble_permission = 0	
	
	config.execute()
	es.msg ("#multi", "Beefs #green[#defaultKibbles & Gibs#green]#default " + info.version + " loaded!")
	#es.regclientcmd('kb_blow', 'kibbles/creategibsmanual', 'Manual GIB from self.')
	# es.regsaycmd('!test', 'kibbles/creategibs')
	# es.regsaycmd('!createbomb', 'kibbles/createtestxplode')
	# es.regsaycmd('!bomb', 'kibbles/testxplode')
	gamethread.delayedname(26, 'stillrunning_timer', stillrunning)
	
def es_map_start(ev):
	addModels()
	addMaterials()
	addSounds()
	gamethread.delayedname(26, 'stillrunning_timer', stillrunning)
def stillrunning():
	es.msg ("#multi", "Beefs #green[#default"+info.name+"#green]#default "+info.version+" is running!")
def addModels():
    for modelTitle in modelList:
        es.stringtable('downloadables', 'models/kibbles/defaultgibs/' + modelTitle)
def addMaterials():
	for materialTitle in materialList:
		es.stringtable('downloadables', 'materials/models/kibbles/defaultgibs/' + materialTitle)
def addSounds():
	for soundTitle in soundList:
		es.stringtable('downloadables', 'sound/kibbles/' + soundTitle)
def round_start(ev):
	global vanish
	global lastbombXYZ
	global c4XYZ
	global angle
	lastbombXYZ = "??? ??? ???"
	c4XYZ = "??? ??? ???"
	angle = "auto"
	vanish = 0
	gamethread.delayed(1, ON)
def round_end(ev):
	gamethread.delayed(3, OFF)
def ON():
	global kibble_permission
	kibble_permission = 1
def OFF():
	global kibble_permission
	kibble_permission = 0

def unload():
	#es.unregclientcmd ('kb_blow')
	# es.unregsaycmd('!test')
	# es.unregsaycmd('!createbomb')
	# es.unregsaycmd('!bomb')
	es.msg ("#multi", "Beefs #green[#defaultKibbles & Gibs#green]#default " + info.version + " unloaded!")
def player_death(ev):
#	es.msg("DEATH ROUTINE")
	if vanish == ev['userid']:
		es.server.queuecmd('es_delayed .1 es_fire ' + str(ev['userid']) + ' cs_ragdoll kill')
	
def player_hurt(ev):
#	es.msg("HURT ROUTINE")
	global vanish
	global c4XYZ
	global c4
	global lastbomb
	player_health = ev['es_userhealth']
	player_damage = ev['dmg_health']
	
	if kibble_permission == 1:
		if (str(player_health)) <= "0":
			if int(player_damage) >= int(gibs_damage):  #Amount of damage needed to explode
	#			es.msg("GIB DECIDE ROUTINE")
				#player_name = ev['es_username']
				player_id = ev['userid']
				#player_attacker = ev['es_attackername']
				player_attackerweap = ev['weapon']
				#gamethread.delayed(.1, gibdecision, (player_name, player_id, player_attacker, player_attackerweap, player_damage, player_health))
				blowangle = [0,1,2]
				mycoords = es.getplayerlocation(player_id)
				mycoordsX = int(mycoords[0])
				mycoordsY = int(mycoords[1])
				mycoordsZ = int(mycoords[2]) + 60
				mycoordsXYZ = str(mycoordsX) + " " + str(mycoordsY) + " " + str(mycoordsZ)
				if str(player_attackerweap) == "hegrenade":
					#es.msg ("Explosion coords: " + str(lastbombXYZ) + "  <><>  " + str(player_name) + "'s coords: " + mycoordsXYZ)
					lastbomb_v = vecmath.vector(lastbomb)
					mycoords_v = vecmath.vector(mycoords)
					#drawtestlines(player_name, player_id, player_attacker, player_attackerweap, player_damage, player_health, lastbombXYZ, mycoordsXYZ)
					blowangle = vecmath.viewangles(lastbomb_v, mycoords_v)
					vanish = player_id
					creategibs(player_id, mycoords, mycoordsXYZ, blowangle)
				elif str(player_attackerweap) == "":
					if c4XYZ != "??? ??? ???":
						lastbomb = c4
						lastbomb[2] = mycoords[2]
						lastbomb_v = vecmath.vector(lastbomb)
						mycoords_v = vecmath.vector(mycoords)
						#drawtestlines(player_name, player_id, player_attacker, player_attackerweap, player_damage, player_health, lastbombXYZ, mycoordsXYZ)
						blowangle = vecmath.viewangles(lastbomb_v, mycoords_v)
						vanish = player_id
						creategibs(player_id, mycoords, mycoordsXYZ, blowangle)
					else:
						blowangle[0] = -90
						blowangle[1] = 0
						blowangle[2] = 0
						#drawtestlines(player_name, player_id, player_attacker, player_attackerweap, player_damage, player_health, lastbombXYZ, mycoordsXYZ)
						# if ragdoll:
							# es.msg("Changing color")
							# es.server.queuecmd("es playerset color " + str(player_id) + " 255 255 255 0")
							# es.server.queuecmd("es_remove " + str(ragdoll))
						vanish = player_id
						creategibs(player_id, mycoords, mycoordsXYZ, blowangle)


			
			
			
			
			
			
def gibdecision(player_name, player_id, player_attacker, player_attackerweap, player_damage, player_health):
	es.msg("GIB DECIDE ROUTINE")
	global c4XYZ
	global c4
	global lastbomb
	blowangle = [0,1,2]
	mycoords = es.getplayerlocation(player_id)
	mycoordsX = int(mycoords[0])
	mycoordsY = int(mycoords[1])
	mycoordsZ = int(mycoords[2]) + 60
	mycoordsXYZ = str(mycoordsX) + " " + str(mycoordsY) + " " + str(mycoordsZ)

#	es.msg ("DEBUG: " + str(player_name) + " took " + str(player_damage) + " damage taken from " + str(player_attacker) + " with a " + str(player_attackerweap))

	if str(player_attackerweap) == "hegrenade":
		#es.msg ("Explosion coords: " + str(lastbombXYZ) + "  <><>  " + str(player_name) + "'s coords: " + mycoordsXYZ)
		lastbomb_v = vecmath.vector(lastbomb)
		mycoords_v = vecmath.vector(mycoords)
		#drawtestlines(player_name, player_id, player_attacker, player_attackerweap, player_damage, player_health, lastbombXYZ, mycoordsXYZ)
		blowangle = vecmath.viewangles(lastbomb_v, mycoords_v)
		creategibs(player_id, mycoords, mycoordsXYZ, blowangle)
	elif str(player_attackerweap) == "":
		if c4XYZ != "??? ??? ???":
			lastbomb = c4
			lastbomb[2] = mycoords[2]
			lastbomb_v = vecmath.vector(lastbomb)
			mycoords_v = vecmath.vector(mycoords)
			#drawtestlines(player_name, player_id, player_attacker, player_attackerweap, player_damage, player_health, lastbombXYZ, mycoordsXYZ)
			blowangle = vecmath.viewangles(lastbomb_v, mycoords_v)
			creategibs(player_id, mycoords, mycoordsXYZ, blowangle)
		else:
			blowangle[0] = -90
			blowangle[1] = 0
			blowangle[2] = 0
			#drawtestlines(player_name, player_id, player_attacker, player_attackerweap, player_damage, player_health, lastbombXYZ, mycoordsXYZ)
			# if ragdoll:
				# es.msg("Changing color")
				# es.server.queuecmd("es playerset color " + str(player_id) + " 255 255 255 0")
				# es.server.queuecmd("es_remove " + str(ragdoll))
			creategibs(player_id, mycoords, mycoordsXYZ, blowangle)
			vanish = player_id


def creategibs(player_id, mycoords, mycoordsXYZ, blowangle):
	soundengine()
	blowangleXYZ = str(blowangle[0]) + " " + str(blowangle[1]) + " " + str(blowangle[2]) + " "
#	es.msg ("DEBUG: Creating body parts at " + str(mycoordsXYZ))


	es.server.queuecmd("es_set kibble_origin_x " + str(mycoords[0]))
	es.server.queuecmd("es_set kibble_origin_y " + str(mycoords[1]))
	es.server.queuecmd("es_set kibble_origin_z " + str(mycoords[2]+20))
	es.server.queuecmd("es_set kibble_origin 0")
	es.server.queuecmd('es_formatv kibble_origin "%1 %2 %3" kibble_origin_x kibble_origin_y kibble_origin_z')
	
	es.server.queuecmd("es_set kibble_angle_x " + str(blowangle[0]))
	es.server.queuecmd("es_set kibble_angle_y " + str(blowangle[1]))
	es.server.queuecmd("es_set kibble_angle_z " + str(blowangle[2]))
	es.server.queuecmd("es_set kibble_angle 0")
	es.server.queuecmd('es_formatv kibble_angle "%1 %2 %3" kibble_angle_x kibble_angle_y kibble_angle_z')


	# es.precachemodel("models/kibbles/defaultgibs/ear.mdl")		# -----------CACHE CUSTOM ENV_SHOOTER MODELS
	# es.precachemodel("models/kibbles/defaultgibs/femur.mdl")
	# es.precachemodel("models/kibbles/defaultgibs/heart.mdl")
	# es.precachemodel("models/kibbles/defaultgibs/stomach.mdl")
	# es.precachemodel("models/kibbles/defaultgibs/verta.mdl")
	# es.precachemodel("models/kibbles/defaultgibs/ribs.mdl")

	es.server.queuecmd("es_xset mdl_brain 0")
	es.server.queuecmd("es_xset mdl_ear 0")
	es.server.queuecmd("es_xset mdl_femur 0")
	es.server.queuecmd("es_xset mdl_heart 0")
	es.server.queuecmd("es_xset mdl_stomach 0")
	es.server.queuecmd("es_xset mdl_verta 0")
	es.server.queuecmd("es_xset mdl_ribs 0")
	es.server.queuecmd('es_precachemodel mdl_brain "models/kibbles/defaultgibs/brain.mdl"')
	es.server.queuecmd('es_precachemodel mdl_ear "models/kibbles/defaultgibs/ear.mdl"')
	es.server.queuecmd('es_precachemodel mdl_femur "models/kibbles/defaultgibs/femur.mdl"')
	es.server.queuecmd('es_precachemodel mdl_heart "models/kibbles/defaultgibs/heart.mdl"')
	es.server.queuecmd('es_precachemodel mdl_stomach "models/kibbles/defaultgibs/stomach.mdl"')
	es.server.queuecmd('es_precachemodel mdl_verta "models/kibbles/defaultgibs/verta.mdl"')
	es.server.queuecmd('es_precachemodel mdl_ribs "models/kibbles/defaultgibs/ribs.mdl"')


	
	es.server.queuecmd("es_createentity env_shooter shooter_brain")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) origin server_var(kibble_origin)")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) amount 100")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) angles server_var(kibble_angle)")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) m_iGibs 1")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) gibanglevelocity 4")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) shootsounds 3")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) spawnflags 1")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) renderamt 255")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) m_flVelocity 200")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) m_flVariance .45")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) m_flGibLife 5")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) gibgravityscale 1")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) simulation 1")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) Model models/kibbles/defaultgibs/brain.mdl")

		#es.server.queuecmd("es_spawnentity shooter_brain")
	es.server.queuecmd("es_fire " + str(player_id) + " shooter_brain shoot")
	es.server.queuecmd("es_delayed .2 es_remove shooter_brain")
	es.server.queuecmd("es_delayed .2 es_remove shooter_brain")
	
	
	es.server.queuecmd("es_createentity env_shooter shooter_ear")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) origin server_var(kibble_origin)")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) amount 100")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) angles server_var(kibble_angle)")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) m_iGibs 2")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) gibanglevelocity 4")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) shootsounds 3")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) spawnflags 1")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) renderamt 255")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) m_flVelocity 300")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) m_flVariance 10.45")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) m_flGibLife 5")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) gibgravityscale 1")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) simulation 1")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) Model models/kibbles/defaultgibs/ear.mdl")

	es.server.queuecmd("es_fire " + str(player_id) + " shooter_ear shoot")
	es.server.queuecmd("es_delayed .2 es_remove shooter_ear")
	es.server.queuecmd("es_delayed .2 es_remove shooter_ear")

	
	es.server.queuecmd("es_createentity env_shooter shooter_femur")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) origin server_var(kibble_origin)")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) amount 100")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) angles server_var(kibble_angle)")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) m_iGibs 2")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) gibanglevelocity 4")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) shootsounds 3")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) spawnflags 1")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) renderamt 255")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) m_flVelocity 200")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) m_flVariance 10.45")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) m_flGibLife 5")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) gibgravityscale 1")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) simulation 1")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) Model models/kibbles/defaultgibs/femur.mdl")

	es.server.queuecmd("es_fire " + str(player_id) + " shooter_femur shoot")
	es.server.queuecmd("es_delayed .2 es_remove shooter_femur")
	es.server.queuecmd("es_delayed .2 es_remove shooter_femur")


	es.server.queuecmd("es_createentity env_shooter shooter_heart")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) origin server_var(kibble_origin)")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) amount 100")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) angles server_var(kibble_angle)")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) m_iGibs 1")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) gibanglevelocity 4")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) shootsounds 3")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) spawnflags 1")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) renderamt 255")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) m_flVelocity 350")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) m_flVariance .75")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) m_flGibLife 5")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) gibgravityscale 1")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) simulation 1")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) Model models/kibbles/defaultgibs/heart.mdl")

	es.server.queuecmd("es_fire " + str(player_id) + " shooter_heart shoot")
	es.server.queuecmd("es_delayed .2 es_remove shooter_heart")
	es.server.queuecmd("es_delayed .2 es_remove shooter_heart")
	

	es.server.queuecmd("es_createentity env_shooter shooter_stomach")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) origin server_var(kibble_origin)")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) amount 100")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) angles server_var(kibble_angle)")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) m_iGibs 1")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) gibanglevelocity 4")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) shootsounds 3")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) spawnflags 1")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) renderamt 255")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) m_flVelocity 250")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) m_flVariance .75")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) m_flGibLife 5")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) gibgravityscale 1")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) simulation 1")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) Model models/kibbles/defaultgibs/stomach.mdl")

	es.server.queuecmd("es_fire " + str(player_id) + " shooter_stomach shoot")
	es.server.queuecmd("es_delayed .2 es_remove shooter_stomach")
	es.server.queuecmd("es_delayed .2 es_remove shooter_stomach")




	

	es.server.queuecmd("es_createentity env_shooter shooter_ribs")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) origin server_var(kibble_origin)")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) amount 100")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) angles server_var(kibble_angle)")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) m_iGibs 1")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) gibanglevelocity 4")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) shootsounds 3")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) spawnflags 1")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) renderamt 255")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) m_flVelocity 200")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) m_flVariance 1.15")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) m_flGibLife 5")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) gibgravityscale 1")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) simulation 1")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) Model models/kibbles/defaultgibs/ribs.mdl")

	es.server.queuecmd("es_fire " + str(player_id) + " shooter_ribs shoot")
	es.server.queuecmd("es_delayed .2 es_remove shooter_ribs")
	es.server.queuecmd("es_delayed .2 es_remove shooter_ribs")
	

	
	# es.server.queuecmd("es_createentity env_shooter shooter_verta")
	# es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) origin server_var(kibble_origin)")
	# es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) amount 100")
	# es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) angles server_var(kibble_angle)")
	# es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) m_iGibs 4")
	# es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) gibanglevelocity 4")
	# es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) shootsounds 3")
	# es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) spawnflags 1")
	# es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) renderamt 255")
	# es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) m_flVelocity 400")
	# es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) m_flVariance 1.15")
	# es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) m_flGibLife 5")
	# es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) gibgravityscale 1")
	# es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) simulation 1")
	# es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) Model models/kibbles/defaultgibs/verta.mdl")

	# es.server.queuecmd("es_fire " + str(player_id) + " shooter_verta shoot")
	# es.server.queuecmd("es_delayed .2 es_remove shooter_verta")
	# es.server.queuecmd("es_delayed .2 es_remove shooter_verta")

#KINDA WORKING
	# es.server.queuecmd("es_createentity env_blood shooter_blood1")
	# es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) origin server_var(kibble_origin)")
	# es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) angles server_var(kibble_angle)")
	# es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) spraydir server_var(kibble_angle)")
	# es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) gibanglevelocity 4")
	# es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) amount 100")
	# es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) color 0")
	# es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) spawnflags 3")
	# es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) renderamt 255")
	# es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) m_flVelocity 200")
	# es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) m_flVariance 3.45")
	# es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) m_flGibLife 5")
	# es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) rendercolor 255 255 255")
	# es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) gibgravityscale 1")

	# es.server.queuecmd("es_fire " + str(player_id) + " shooter_blood1 EmitBlood")  #particledefault texture required!
	# es.server.queuecmd("es_delayed .1 es_fire " + str(player_id) + " shooter_blood1 EmitBlood")  #particledefault texture required!
	# es.server.queuecmd("es_delayed .2 es_fire " + str(player_id) + " shooter_blood1 EmitBlood")  #particledefault texture required!
	# es.server.queuecmd("es_delayed .3 es_fire " + str(player_id) + " shooter_blood1 EmitBlood")  #particledefault texture required!
	# es.server.queuecmd("es_delayed .4 es_fire " + str(player_id) + " shooter_blood1 EmitBlood")  #particledefault texture required!
	# es.server.queuecmd("es_delayed .5 es_fire " + str(player_id) + " shooter_blood1 EmitBlood")  #particledefault texture required!
	# es.server.queuecmd("es_delayed .6 es_fire " + str(player_id) + " shooter_blood1 EmitBlood")  #particledefault texture required!
	# es.server.queuecmd("es_delayed .7 es_fire " + str(player_id) + " shooter_blood1 EmitBlood")  #particledefault texture required!
	# es.server.queuecmd("es_delayed .8 es_fire " + str(player_id) + " shooter_blood1 EmitBlood")  #particledefault texture required!
	# es.server.queuecmd("es_delayed .9 es_remove shooter_blood1")
	# es.server.queuecmd("es_delayed .9 es_remove shooter_blood1")
	# es.server.queuecmd("es_delayed .9 es_remove shooter_blood1")
	# es.server.queuecmd("es_delayed .9 es_remove shooter_blood1")
	# es.server.queuecmd("es_delayed .9 es_remove shooter_blood1")
	# es.server.queuecmd("es_delayed .9 es_remove shooter_blood1")	
	# es.server.queuecmd("es_delayed .9 es_remove shooter_blood1")
	# es.server.queuecmd("es_delayed .9 es_remove shooter_blood1")
	# es.server.queuecmd("es_delayed .9 es_remove shooter_blood1")		
	
#NOT WORKING
	# es.server.queuecmd("es_createentity gibshooter gibshooter1")
	# es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) origin server_var(kibble_origin)")
	# es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) angles server_var(kibble_angle)")
	# es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) spawnflags 0")
	# es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) m_iGibs 6")
	# es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) delay 0")
	# es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) gibangles 1 1 1")
	# es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) m_flVelocity 250")
	# es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) m_flVariance 0")
	# es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) m_flGibLife 1")

	# es.server.queuecmd("es_fire " + str(player_id) + " gibshooter1 shoot")
	# es.server.queuecmd("es_delayed .2 es_remove gibshooter1")
	# es.server.queuecmd("es_delayed .2 es_remove gibshooter1")
	

def creategibsmanual():
	player_id = es.getcmduserid()
	blowangle = [0,1,2]
	mycoords = es.getplayerlocation(player_id)
	mycoordsX = int(mycoords[0])
	mycoordsY = int(mycoords[1])
	mycoordsZ = int(mycoords[2]) + 60
	mycoordsXYZ = str(mycoordsX) + " " + str(mycoordsY) + " " + str(mycoordsZ)
	creategibs(player_id, mycoords, mycoordsXYZ, blowangle)
def createtestxplode():
	# es.precachemodel("models/props/de_train/pallet_barrels.mdl")
	# es.precachemodel("sprites/zerogxplode.spr")
	es.server.queuecmd("es_xset mdl_pallet 0")
	es.server.queuecmd('es_precachemodel mdl_pallet "models/props/de_train/pallet_barrels.mdl"')
	es.server.queuecmd("es_xset mdl_xplode 0")
	es.server.queuecmd('es_precachemodel mdl_xplode "sprites/zerogxplode.spr"')	
	
	userid = es.getcmduserid()
	es.server.queuecmd("es playerset color " + str(userid) + " 1 255 255 0")
	mycoords = es.getplayerlocation(userid)
	mycoordsX = int(mycoords[0])
	mycoordsY = int(mycoords[1])
	mycoordsZ = int(mycoords[2])
	mycoordsXYZ = str(mycoordsX) + " " + str(mycoordsY) + " " + str(mycoordsZ)
	es.msg ("DEBUG: Bomb created!")

	es.server.queuecmd("es_set mycoordsX " + str(mycoords[0]))
	es.server.queuecmd("es_set mycoordsY " + str(mycoords[1]))
	es.server.queuecmd("es_set mycoordsZ " + str(mycoords[2]))
	es.server.queuecmd("es_set mycoordsXYZ 0")
	es.server.queuecmd('es_formatv mycoordsXYZ "%1 %2 %3" mycoordsX mycoordsY mycoordsZ')
	
	es.server.queuecmd("es_createentity env_explosion xplode")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) origin server_var(mycoordsXYZ)")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) iMagnitude 250")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) iRadiusOverride 0")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) fireballsprite sprites/zerogxplode.spr")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) rendermode Normal")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) Spawnflags 2")
	es.server.queuecmd("es_spawnentity server_var(eventscripts_lastgive)")
	
	# xplode = es.createentity("env_explosion", "xplode")
	# es.entitysetvalue(xplode, "origin", mycoordsXYZ)
	# es.entitysetvalue(xplode, "iMagnitude", "250")
	# es.entitysetvalue(xplode, "iRadiusOverride", "")
	# es.entitysetvalue(xplode, "fireballsprite", "sprites/zerogxplode.spr")
	# es.entitysetvalue(xplode, "rendermode", "Normal")
	# es.entitysetvalue(xplode, "Spawnflags", "2")
	# es.spawnentity(xplode)
	
	
	es.server.queuecmd("es_createentity prop_dynamic dyno")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) origin server_var(mycoordsXYZ)")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) model models/props/de_train/pallet_barrels.mdl")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) angles 0 0 0")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) solid 0")
	#es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) rendercolor 255 255 255")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) fademindist -1")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) renderamt 255")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) fadescale 1")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) MaxAnimTime 10")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) MinAnimTime 5")
	es.server.queuecmd("es_entitysetvalue server_var(eventscripts_lastgive) Skin 0")
	es.server.queuecmd("es_spawnentity server_var(eventscripts_lastgive)")
	
	# dyno = es.createentity("prop_dynamic", "dyno")
	# es.entitysetvalue(dyno, "origin", mycoordsXYZ)
	# es.entitysetvalue(dyno, "model", "models/props/de_train/pallet_barrels.mdl")
	# es.entitysetvalue(dyno, "angles", "0 0 0")
	# es.entitysetvalue(dyno, "solid", "0")
	# es.entitysetvalue(dyno, "rendercolor", "255 255 255")
	# es.entitysetvalue(dyno, "fademindist", "-1")
	# es.entitysetvalue(dyno, "renderamt", "255")
	# es.entitysetvalue(dyno, "fadescale", "1")
	# es.entitysetvalue(dyno, "MaxAnimTime", "10")
	# es.entitysetvalue(dyno, "MinAnimTime", "5")

	# es.entitysetvalue(dyno, "Skin", "0")
	# es.spawnentity(dyno)
def testxplode():
	userid = es.getcmduserid()
	# es.fire(userid, "xplode", "Explode")
	es.server.queuecmd("es_fire " + str(userid) + " xplode Explode")


def entremove(userid, ent):
	es.fire(userid, str(ent), "KillHierarchy")

def hegrenade_detonate(ev):
	global lastbombXYZ
	global lastbomb
	
	lastbomb[0] = int(round(float(ev['x'])))
	lastbomb[1] = int(round(float(ev['y'])))
	lastbomb[2] = int(round(float(ev['z'])))
	lastbombXYZ = str(lastbomb[0]) + " " + str(lastbomb[1]) + " " + str(lastbomb[2])

def bomb_planted(ev):
	global c4
	global c4XYZ
	c4[0] = int(round(float(ev['posx'])))
	c4[1] = int(round(float(ev['posy'])))
	c4[2] = "0"
	c4XYZ = str(c4[0]) + " " + str(c4[1]) + " " + str(c4[2])
	
def drawtestlines(player_name, player_id, player_attacker, player_attackerweap, player_damage, player_health, lastbombXYZ, mycoordsXYZ):
	# save the userids to local variables:
	victim = int(player_id)
	attacker = int(player_id)
	if attacker:
		#es.msg ("Drawing Test Beam...")
		# get the player locations as vecmath.vectors for better manipulation
		victim_location = vecmath.vector(es.getplayerlocation(victim))
		attacker_location = lastbomb
        
		# check attacker crouching state and adjust z coordinate accordingly
		#attacker_location['z'] += 1
        
		# draw a beam using effectlib
		# note that you can do simple vector math inline, like adding values:
		effectlib.drawLine(attacker_location, victim_location + (0,0,96/2), seconds=5)
		
	
def soundengine():
	sound = random.randint(0, 2)
	if sound == 0:
		es.server.queuecmd("es_cexec_all play kibbles/gib.mp3")
	if sound == 1:
		es.server.queuecmd("es_cexec_all play kibbles/tornoff2.mp3")
	if sound == 2:
		es.server.queuecmd("es_cexec_all play kibbles/udeath.mp3")

